package de.fhhannover.inform.trust.ifmapj.channel;

import de.fhhannover.inform.trust.ifmapj.exception.EndSessionException;
import de.fhhannover.inform.trust.ifmapj.exception.IfmapErrorResult;
import de.fhhannover.inform.trust.ifmapj.exception.IfmapException;
import de.fhhannover.inform.trust.ifmapj.messages.PollResult;

/**
 * Interface describing the Asynchronous Receive Channel (ARC) methods.
 * 
 * @author aw
 *
 */
public interface ARC extends IfmapChannel {
	
	/**
	 * Send a poll on the ARC. This is a blocking method that returns when the
	 * poll results from the MAPS have been received.
	 * 
	 * @return the poll results that have been received from the MAPS
	 * @throws IfmapErrorResult
	 * @throws EndSessionException
	 * @throws IfmapException
	 */
	public PollResult poll() throws IfmapErrorResult, EndSessionException, IfmapException;

}
