package de.fhhannover.inform.trust.ifmapj.messages;

import de.fhhannover.inform.trust.ifmapj.identifier.Identifier;

/**
 * Interface to access to data related to the search operation.
 * 
 * Both, {@link SearchRequest} and {@link SubscribeUpdate} hold information
 * about the parameters used for a search operation. This interface provides
 * access to this information.
 * 
 * Except for the start {@link Identifier}, all other attributes are optional
 * and may be set to zero, to indicate the attribute is not to be sent to the
 * MAPS.
 * 
 * @author aw
 *
 */
public interface SearchHolder extends NamespaceDeclarationHolder {
	
	/**
	 * @return the identifier where the search is to be started.
	 */
	public Identifier getStartIdentifier();

	/**
	 * @param startIdentifier
	 * @throws NullPointerException if the given identifier is null.
	 */
	public void setStartIdentifier(Identifier startIdentifier);

	public String getMatchLinksFilter();

	public void setMatchLinksFilter(String matchLinksFilter);

	public Integer getMaxDepth();

	public void setMaxDepth(Integer maxDepth);

	public String getTerminalIdentifierTypes();

	public void setTerminalIdentifierTypes(String terminalIdentifierTypes);

	public Integer getMaxSize();

	public void setMaxSize(Integer maxSize);

	public String getResultFilter();

	public void setResultFilter(String resultFilter);
}
