package de.fhhannover.inform.trust.ifmapj.messages;

import java.util.Collection;

import util.Pair;
import de.fhhannover.inform.trust.ifmapj.identifier.Identifier;

class SearchHolderImpl implements SearchHolder {

	private Identifier mStartIdentifier;
	
	private String mMatchLinksFilter;
	
	private Integer mMaxDepth;
	
	private String mTerminalIdentifierTypes;
	
	private Integer mMaxSize;
	
	private String mResultFilter;
	
	private final NamespaceDeclarationHolder mNamespaces;
	
	/**
	 * package constructor
	 */
	SearchHolderImpl() {
		mNamespaces = new NamespaceDeclarationHolderImpl();
	}

	@Override
	public Identifier getStartIdentifier() {
		return mStartIdentifier;
	}

	@Override
	public void setStartIdentifier(Identifier startIdentifier) {
		mStartIdentifier = startIdentifier;
	}

	@Override
	public String getMatchLinksFilter() {
		return mMatchLinksFilter;
	}

	@Override
	public void setMatchLinksFilter(String matchLinksFilter) {
		mMatchLinksFilter = matchLinksFilter;
	}

	@Override
	public Integer getMaxDepth() {
		return mMaxDepth;
	}

	@Override
	public void setMaxDepth(Integer maxDepth) {
		mMaxDepth = maxDepth;
	}

	@Override
	public String getTerminalIdentifierTypes() {
		return mTerminalIdentifierTypes;
	}

	@Override
	public void setTerminalIdentifierTypes(String terminalIdentifierTypes) {
		mTerminalIdentifierTypes = terminalIdentifierTypes;
	}

	@Override
	public Integer getMaxSize() {
		return mMaxSize;
	}

	@Override
	public void setMaxSize(Integer maxSize) {
		mMaxSize = maxSize;
	}

	@Override
	public String getResultFilter() {
		return mResultFilter;
	}

	@Override
	public void setResultFilter(String resultFilter) {
		mResultFilter = resultFilter;
	}
	
	/*
	 * We simply delegate those calls, so we can reuse some code...
	 * 
	 * (non-Javadoc)
	 * @see de.fhhannover.inform.trust.ifmapj.request.NamespaceDeclarationHolder#addNamespaceDeclaration(java.lang.String, java.lang.String)
	 */
	@Override
	public void addNamespaceDeclaration(String prefix, String uri) {
		mNamespaces.addNamespaceDeclaration(prefix, uri);
	}

	/*
	 * We simply delegate those calls, so we can reuse some code...
	 * 
	 * (non-Javadoc)
	 * @see de.fhhannover.inform.trust.ifmapj.request.NamespaceDeclarationHolder#getNamespaceDeclarations()
	 */
	@Override
	public Collection<Pair<String, String>> getNamespaceDeclarations() {
		return mNamespaces.getNamespaceDeclarations();
	}
}
