package de.fhhannover.inform.trust.ifmapj.result;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.LinkedList;
import java.util.List;

import org.junit.Test;
import org.w3c.dom.Document;

import de.fhhannover.inform.trust.ifmapj.IfmapJ;
import de.fhhannover.inform.trust.ifmapj.identifier.IdentifierFactory;
import de.fhhannover.inform.trust.ifmapj.identifier.IpAddress;
import de.fhhannover.inform.trust.ifmapj.identifier.MacAddress;
import de.fhhannover.inform.trust.ifmapj.messages.ResultFactory;
import de.fhhannover.inform.trust.ifmapj.messages.ResultFactoryImpl;
import de.fhhannover.inform.trust.ifmapj.messages.ResultItem;
import de.fhhannover.inform.trust.ifmapj.messages.SearchResult;
import de.fhhannover.inform.trust.ifmapj.metadata.StandardIfmapMetadataFactory;

/**
 * Trivial tests for class {@link SearchResult}.
 * 
 * @author ibente
 * 
 * TODO: It doesn't really work like that anymore... :(
 * 
 * ResultFactory is now used to create Results which are visible
 * for the user. It is not possible to modify these results after
 * they have been created...
 * I'm too tired right now to write real tests...
 * 
 * FIXME: It's still no real test.
 *
 */
public class SearchResultTest {

	private ResultFactory rf = new ResultFactoryImpl();
	private StandardIfmapMetadataFactory mf = IfmapJ.createStandardMetadataFactory();
	
	@Test (expected=NullPointerException.class)
	public void testAddResultItemNull() {
		SearchResult sr = rf.createSearchRes(null);
		sr.getName();
	}
	
	@Test
	public void testAddResultItem() {
		IdentifierFactory iFactory = IfmapJ.createIdentifierFactory();
		List<ResultItem> rlist = new LinkedList<ResultItem>();
		List<Document> mdlist = new LinkedList<Document>();
		
		IpAddress ip = iFactory.createIp4("192.168.0.1");
		MacAddress mac = iFactory.createMac("11:22:33:aa:bb:cc");
		mdlist.add(mf.createIpMac());
		
		ResultItem ri = rf.createResultItem(ip, mac, mdlist);
		ri.addMetadata(mf.createIpMac());
		rlist.add(ri);
		
		SearchResult sr = rf.createSearchRes(rlist);
	
		assertTrue(ri.holdsLink());
		assertEquals(1, sr.getResultItems().size());
		assertTrue(sr.getResultItems().contains(ri));
		assertEquals(2, sr.getResultItems().iterator().next().getMetadata().size());
		assertTrue(sr.getResultItems().iterator().next().holdsLink());
	}
}
